/**
 * Integrates a 1D signal
 * @author: Joseph Jennings
 * @version: 2017.02.14
 */
#ifndef INTEGRATE1D_H_
#define INTEGRATE1D_H_

#include "my_operator.h"
#include "axis.h"

class integrate1d : public my_operator {
  public:
    integrate1d(){};
    integrate1d(axis at);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~integrate1d(){};
  private:
    int _nt;
};

#endif /* INTEGRATE1D_H_ */
