from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np

fig = plt.figure()
ax = fig.add_subplot(111, projection = "3d")

ax.set_xlabel("x")
ax.set_ylabel("y") 
ax.set_zlabel("z")
ax.set_xlim3d(0,10)
ax.set_ylim3d(0,10) 
ax.set_zlim3d(0,10) 

xpos = [[0,1,2],[0,1,2,2],[0,1],[0,1]]
ypos = [[0,0,0],[0,0,0,1],[0,0],[0,0]]
zpos = [[0,0,0],[1,1,1,1],[2,2],[3,3]]

dx = np.ones(10)
dy = np.ones(10)
dz = [1,1,1,1]  # the heights of the 4 bar sets

_zpos = zpos   # the starting zpos for each bar
for i in range(len(dz)-1):
 # print _zpos[i],xpos[i],ypos[i]
  ax.bar3d(xpos[i], ypos[i], _zpos[i], dx, dy, dz[i])

ax.bar3d(xpos[-1],ypos[-1],_zpos[-1],dx,dy,dz[-1])

plt.gca().invert_xaxis()
plt.show()
