from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np

fig = plt.figure()
ax = fig.add_subplot(111, projection = "3d")

ax.set_xlabel("x")
ax.set_ylabel("y") 
ax.set_zlabel("t")
ax.set_xlim3d(0,10)
ax.set_ylim3d(0,10) 
ax.set_zlim3d(0,10)

# Format:
# x,y,z, dx=1,dy=1,dz=1
ax.bar3d(0,0,0,1,1,1,color='w')
ax.bar3d(0,0,1,1,1,1,color='w')
ax.bar3d(0,0,2,1,1,1,color='r')
ax.bar3d(1,0,0,1,1,1,color='w')
ax.bar3d(1,0,1,1,1,1,color='w')
ax.bar3d(1,0,2,1,1,1,color='w')
ax.bar3d(1,0,3,1,1,1,color='w')
ax.bar3d(1,0,4,1,1,1,color='w')
ax.bar3d(2,0,0,1,1,1,color='w')
ax.bar3d(2,0,1,1,1,1,color='w')
ax.bar3d(2,0,2,1,1,1,color='w')
ax.bar3d(2,0,3,1,1,1,color='w')
ax.bar3d(2,0,4,1,1,1,color='w')

plt.show()
