/**
 * A mask operator to constrain
 * the first coefficient when
 * estimating a PEF
 * @author: Joseph Jennings
 * @version: 2017.03.05
 */

#ifndef PEFMASK_H_
#define PEFMASK_H_

#include "my_operator.h"

class pefmask: public my_operator {
  public:
    pefmask(){};
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~pefmask(){};
};

#endif /* PEFMASK_H_ */
