/**
 * it-1 finite difference coefficient
 * without absorbing boundaries
 * @author: Joseph Jennings
 * @version: 2016.11.27
 */
#ifndef FDCOEFNB_H_
#define FDCOEFNB_H_

#include "fdcoef.h"

class fdcoefnb : public fdcoef {
  public:
    fdcoefnb(){};
    fdcoefnb(std::vector<axis> uaxis, laplacian* lapop, hypercube_float *v2dt2);
    virtual bool forward(bool add, my_vector *model, my_vector *data);
    virtual bool adjoint(bool add, my_vector *model, my_vector *data);
    ~fdcoefnb() {}
};

#endif /* FDCOEFNB_H_ */
