/**
 * Receiver restriction operator
 * @author: Joseph Jennings
 * @version: 2016.12.27
 */
#ifndef RREC_H_
#define RREC_H_

#include "my_operator.h"
#include "axis.h"

class rrec : public my_operator {

  public:
    rrec(){};
    //TODO: Change int recz to a receiver z coordinate (float)
    rrec(axis recx, int recz);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~rrec(){};

  private:
    int _rnx;
    float _rox, _rdx;
    int _recz;

};

#endif /* RREC_H_ */
