/**
 * First-order second derivative
 * operator
 * @author: Joseph Jennings
 * @version: 2016.12.28
 */
#ifndef SCNDDER_H_
#define SCNDDER_H_

#include "my_operator.h"
#include "axis.h"

class scndder : public my_operator {
  public:
    scndder(){};
    scndder(axis at);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~scndder(){}

  private:
    int _nt; float _ot, _idt2;
};

#endif /* SCNDDER_H_ */
