/**
 * Linear interpolation operator intended
 * for wave propagation (interpolating the temporal
 * axis of a wavefield)
 * @author: Joseph Jennings
 * @version: 2016.11.24
 */
#ifndef WFLDLINT_H_
#define WFLDLINT_H_

#include <tuple>
#include "my_operator.h"
#include "my_vector.h"
#include "hypercube_float.h"

class wfldlint : public my_operator {
  public:
    wfldlint(){};
    virtual bool forward(bool add, my_vector *mod, my_vector *dat);
    virtual bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~wfldlint(){};

};

#endif /* WFLDLINT_H_ */
